HYPER-V(4)

NAME
hv_kvp - Hyper-V Key Value Pair Driver

SYNOPSIS
To compile this driver into the kernel, place the following lines in the system kernel configuration file:

device hyperv

DESCRIPTION
The hv_kvp driver provides the ability to store, retrieve, modify and delete key value pairs for FreeBSD guest partitions running on Hyper-V. Hyper-V allows administrators to store custom metadata in the form of key value pairs inside the FreeBSD guest partition. Administrators can use Windows Powershell scripts to add, read, modify and delete such key value pairs.

The driver is bare bones and merely forwards requests to its counterpart user mode daemon, hv_kvp_daemon(8). The daemon maintains pools of key value pairs and does the actual metadata management.

The same driver and daemon combination are also used to set and get IP addresses from a FreeBSD guest.

The set functionality is particularly useful when the FreeBSD guest is assigned a static IP address and is failed over from one Hyper-V host to another. After failover, Hyper-V uses the set IP functionality to automatically update the FreeBSD guest's IP address to its original static value.

On the other hand, the get IP functionality is used to update the guest IP address in the Hyper-V management console window.

SEE ALSO
hv_ata_pci_disengage(4), hv_netvsc(4), hv_storvsc(4), hv_utils(4), hv_vmbus(4), hv_kvp_daemon(8)

HISTORY
Support for hv_kvp first appeared in FreeBSD 10.0. The driver was developed through a joint effort between Citrix Incorporated, Microsoft Corporation and Network Appliance Incorporated.

AUTHORS
-nosplit FreeBSD support for hv_kvp was first added by Microsoft BSD Integration Services Team <bsdic@microsoft.com>.